include masm32rt.inc
XorCrypt proto pKey: ptr BYTE,pData: ptr BYTE,cb:DWORD
.code
main proc
LOCAL hKeyFile:HANDLE
LOCAL hDataFile:HANDLE
LOCAL hMap:HANDLE
LOCAL sysinfo:SYSTEM_INFO
LOCAL cb:DWORD
LOCAL qwFileOffset:QWORD
LOCAL qwFileSize[2]:QWORD

	invoke GetSystemInfo,ADDR sysinfo
	
	.if fopen("key.txt") != INVALID_HANDLE_VALUE
		mov hKeyFile,eax
	.else
		print "can't open key.txt",13,10
		inkey
		exit
	.endif
	
	.if fopen("data.txt") != INVALID_HANDLE_VALUE
		mov hDataFile,eax
	.else
		print "can't open data.txt",13,10
		inkey
		exit
	.endif

	mov esi,fsize(hKeyFile)
	.if !esi
		print "zero-length key",13,10
		inkey
		exit
	.endif

	mov ebx,alloc(esi)
	.if fread(hKeyFile,ebx,esi) != esi
		print "error while reading key file",13,10
		inkey
		exit
	.endif
	
	;/* calculate minimum size of buffer that holds key-data */
	.if esi <= sysinfo.dwAllocationGranularity
		m2m cb,sysinfo.dwAllocationGranularity
		mov edi,alloc(sysinfo.dwAllocationGranularity)
	.else
		xor edx,edx
		mov eax,esi
		div sysinfo.dwAllocationGranularity
		.if edx
			lea eax,[eax+1]
		.endif
		mov cb,eax
		mov edi,alloc(eax)
	.endif
	
	;/* copy/duplicate key-data as needed */
	xor ecx,ecx
	xor edx,edx
	.while ecx < cb
		.if edx >= esi
			xor edx,edx
		.endif			
		movzx eax,BYTE ptr [ebx+edx]
		mov [edi+ecx],al
		lea ecx,[ecx+1]
		lea edx,[edx+1]
	.endw	
	
	free ebx

	;/* get file size */
	mov DWORD ptr qwFileSize[0],rv(GetFileSize,hDataFile,ADDR qwFileSize[4])
	m2m DWORD ptr qwFileSize[8],DWORD ptr qwFileSize[0]
	m2m DWORD ptr qwFileSize[12],DWORD ptr qwFileSize[4]

	;/* create file mapping */
	.if rv(CreateFileMapping,hDataFile,0,PAGE_READWRITE,0,0,0)
		mov hMap,eax
	.else
		print "can't create file mapping",13,10
		inkey
		exit
	.endif

	mov DWORD ptr qwFileOffset[0],0
	mov DWORD ptr qwFileOffset[4],0
	;/* loop until file-size = 0*/
	.while DWORD ptr qwFileSize[0] != 0 || DWORD ptr qwFileSize[4] != 0

		mov eax,DWORD ptr qwFileSize[8]
		mov edx,DWORD ptr qwFileSize[12]
		sub eax,DWORD ptr qwFileOffset[0]
		sbb edx,DWORD ptr qwFileOffset[4]

		;/* check for last block/bytes */
		.if !edx && eax < cb
			mov esi,eax
		.else
			mov esi,cb
		.endif
		.if rv(MapViewOfFile,hMap,FILE_MAP_WRITE,DWORD ptr qwFileOffset[4],DWORD ptr qwFileOffset[0],esi)
			mov ebx,eax
			invoke XorCrypt,edi,ebx,esi
			invoke UnmapViewOfFile,ebx
		.else	
			print "mapping error",13,10
			inkey
			exit
		.endif

		;/* update file location */
		add DWORD ptr qwFileOffset[0],esi
		adc DWORD ptr qwFileOffset[4],0
		sub DWORD ptr qwFileSize[0],esi
		sbb DWORD ptr qwFileSize[4],0
	.endw

	invoke CloseHandle,hMap
	fclose hKeyFile
	fclose hDataFile
	
	free edi
	
	print "-OK-",13,10
	inkey
	exit
	
main endp

XorCrypt proc uses edi esi pKey: ptr BYTE,pData: ptr BYTE,cb:DWORD
	
	mov edi,pData
	mov esi,pKey
	xor ecx,ecx
	.while ecx < cb
		movzx edx,BYTE ptr [edi+ecx]
		movzx eax,BYTE ptr [esi+ecx]
		xor edx,eax
		mov [edi+ecx],dl
		lea ecx,[ecx+1]
	.endw
	
	ret
	
XorCrypt endp
end main